searchData={"items":[{"type":"module","title":"Jieba","doc":"Wrapper for the [jieba-rs](https://github.com/messense/jieba-rs) project,\na Rust implementation of the Python [Jieba](https://github.com/fxsjy/jieba)\nChinese Word Segmentation library.\n\nThis module directly mostly projects the Rust API into Elixir with an\nobject-oriented imperative API with very thin syntactic sugar. Where possible,\nit attempts to preserve functional behavior but this is not possible always,\nespecially with the `load_dict/2` interface.","ref":"Jieba.html"},{"type":"function","title":"Jieba.add_word/4","doc":"Adds a segment to the dictionary with an optional frequency or tag.\n\nIf no frequency is given, `suggest_freq()` is used to guess the frequency.\nThis can be used to prevent over-segmentation.\n\nReturns 2434 (frequency of the added segment)","ref":"Jieba.html#add_word/4"},{"type":"function","title":"Examples - Jieba.add_word/4","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.cut(jieba, \"「台中」正确应该不会被切开\", true)\n    [\"「\", \"台\", \"中\", \"」\", \"正确\", \"应该\", \"不会\", \"被\", \"切开\"]\n    iex> Jieba.add_word(jieba, \"台中\", nil, nil)\n    69\n    iex> Jieba.cut(jieba, \"「台中」正确应该不会被切开\", true)\n    [\"「\", \"台中\", \"」\", \"正确\", \"应该\", \"不会\", \"被\", \"切开\"]","ref":"Jieba.html#add_word/4-examples"},{"type":"function","title":"Jieba.clone/1","doc":"Makes another Jieba with the same dictionary state.\n\nReturns Jieba instance.","ref":"Jieba.html#clone/1"},{"type":"function","title":"Examples - Jieba.clone/1","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.clone(jieba)","ref":"Jieba.html#clone/1-examples"},{"type":"function","title":"Jieba.cut/1","doc":"Uses Rust-side, process-global, Jieba instance to break a sentence into a\nvector of segments without hmm disabled.\n\nThis method is not guaranteed to be thread-safe on the rust-side since the\nJieba_rs API does specify thread-safety guarantees on multiple calls to cut.\n\nAlso, this API does not allow for loading custom dictionaries and the\ndisabling of hmm often yields over-segmentation.\n\nPrefer cut/3 instead.\n\nReturns `[\"李小福\", \"是\"]`","ref":"Jieba.html#cut/1"},{"type":"function","title":"Examples - Jieba.cut/1","doc":"iex> Jieba.cut(\"李小福是创新办任也是云计算方面的家\")\n    [\"李\", \"小\", \"福\", \"是\", \"创新\", \"办\", \"任\", \"也\", \"是\", \"云\", \"计算\", \"方面\", \"的\", \"家\"]","ref":"Jieba.html#cut/1-examples"},{"type":"function","title":"Jieba.cut/3","doc":"Takes a sentence and breaks it into a vector of segments.\n\nReturns `[\"李小福\", \"是\"]`","ref":"Jieba.html#cut/3"},{"type":"function","title":"Examples - Jieba.cut/3","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.cut(jieba, \"李小福是创新办任也是云计算方面的家\", true)\n    [\"李小福\", \"是\", \"创新\", \"办任\", \"也\", \"是\", \"云\", \"计算\",\n     \"方面\", \"的\", \"家\"]","ref":"Jieba.html#cut/3-examples"},{"type":"function","title":"Jieba.cut_all/2","doc":"Takes a sentence and breaks it into a vector containing segments using\nthe most aggressive segmentation possible given the input dictionary.\nIt is likely that it will produce an over-segmented results. There may\nalso be multiple tokens returned any sequence of characters. For example,\n`\"创新\"` will return `[\"创\", \"创新\", \"新\"]`.\n\nThis means that joining all elements of the result vector will not\nnecessarily result in a string with the same meaning as the input.\n\nReturns `[\"李\", \"小\", \"福\", \"是\", \"创\", \"创新\", ...]`","ref":"Jieba.html#cut_all/2"},{"type":"function","title":"Examples - Jieba.cut_all/2","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.cut_all(jieba, \"李小福是创新办任也是云计算方面的家\")\n    [\"李\", \"小\", \"福\", \"是\", \"创\", \"创新\", \"新\", \"办\", \"任\", \"也\", \"是\", \"云\", \"计\", \"计算\", \"算\", \"方\", \"方面\", \"面\", \"的\", \"家\"]","ref":"Jieba.html#cut_all/2-examples"},{"type":"function","title":"Jieba.cut_for_search/3","doc":"Takes a sentence and breaks it into a vector containing segments tuned for\nsearch engine keyword matching.  This tends to produce shorted segments\nthat are more likely to produce a keyword match. For example,\n`\"中国科学院\"` will produce `[\"中国\", \"科学\", \"学院\", \"科学院\", \"中国科学院\"]`\nwhereas with `cut()`, it will just produce `[\"中国科学院\"]`\nIt is possible (and likely) that phrases will be repeated.\n\nReturns `[\"中国\", \"科学\", \"学院\", \"科学院\", \"中国科学院\"]`","ref":"Jieba.html#cut_for_search/3"},{"type":"function","title":"Examples - Jieba.cut_for_search/3","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.cut(jieba, \"小明硕士毕业于中国科学院计算所，后在日本京都大学深造\", true)\n    [\"小明\", \"硕士\", \"毕业\", \"于\", \"中国科学院\", \"计算所\", \"，\", \"后\", \"在\", \"日本京都大学\", \"深造\"]\n    iex> Jieba.cut_for_search(jieba, \"小明硕士毕业于中国科学院计算所，后在日本京都大学深造\", true)\n    [\"小明\", \"硕士\", \"毕业\", \"于\", \"中国\", \"科学\", \"学院\", \"科学院\", \"中国科学院\", \"计算\",\n     \"计算所\", \"，\", \"后\", \"在\", \"日本\", \"京都\", \"大学\", \"日本京都大学\", \"深造\"]","ref":"Jieba.html#cut_for_search/3-examples"},{"type":"function","title":"Jieba.load_dict/2","doc":"Merges the entries in `_dict_path` to the current native Jieba instance\n\nThis is an imperative function and will modify the underlying state of the\nJieba instance.  The function will return a new Jieba that has the\n`Jieba.dict_paths` field updated. However, since both the original\ninput object and the returned object will share a native jieba instance,\nthey will both be altered even if the `dict_paths` field of the original\nobject is left untouched.  The original object should be discarded after\nuse.\n\nIf you wish to keep the original Jieba instance, use `clone/1` to make\na copy that can be preserved.\n\nReturns `(:ok, rust_jieba)`","ref":"Jieba.html#load_dict/2"},{"type":"function","title":"Examples - Jieba.load_dict/2","doc":"# Show that the original jieba instance and the returned ones are entangled even\n    # if the dict_paths are different.\n    iex> jieba = Jieba.new!()\n    iex> {:ok, new_jieba} = Jieba.load_dict(jieba, \"test/example_userdict.txt\")\n    iex> jieba.dict_paths\n    []\n    iex> new_jieba.dict_paths\n    [\"test/example_userdict.txt\"]\n    iex> new_jieba.native == jieba.native\n    true\n\n    # Show the effect of the entanglement on the cut/3 function.\n    iex> jieba = Jieba.new!()\n    iex> old_cut = Jieba.cut(jieba, \"李小福是创新办任也是云计算方面的家\", true)\n    [\"李小福\", \"是\", \"创新\", \"办任\", \"也\", \"是\", \"云\", \"计算\",\n     \"方面\", \"的\", \"家\"]\n    iex> {:ok, new_jieba} = Jieba.load_dict(jieba, \"test/example_userdict.txt\")\n    iex> new_cut = Jieba.cut(new_jieba, \"李小福是创新办任也是云计算方面的家\", true)\n    [\"李小福\", \"是\", \"创新办\", \"任\", \"也\", \"是\", \"云\", \"计算\",\n     \"方面\", \"的\", \"家\"]\n    iex> new_cut == old_cut\n    false\n    iex> old_cut == Jieba.cut(jieba, \"李小福是创新办任也是云计算方面的家\", true)\n    false\n\n    # Show error handling\n    iex> jieba = Jieba.new!()\n    iex> {:error, :enoent} = Jieba.load_dict(jieba, \"NotAFile.nope.nope\")\n    iex> {:error, invalid_entry} = Jieba.load_dict(jieba, \"test/malformed_userdict.txt\")\n    iex> invalid_entry\n    \"line 5 `This is an invalid entry.\\n` frequency is is not a valid integer: invalid digit found in string\"","ref":"Jieba.html#load_dict/2-examples"},{"type":"function","title":"Jieba.load_dict!/2","doc":"Merges the entries in `dict_path` to the current native Jieba instance using load_dict/2.\n\nPlease see load_dict/2 for caveats about imperative behavior.\n\nReturns Jieba instance with merged dictionary.\n\nRaises Jieba.JiebaError on error.","ref":"Jieba.html#load_dict!/2"},{"type":"function","title":"Examples - Jieba.load_dict!/2","doc":"iex> jieba = Jieba.new!()\n    iex> new_jieba = Jieba.load_dict!(jieba, \"test/example_userdict.txt\")\n    iex> Jieba.cut(new_jieba, \"李小福是创新办任也是云计算方面的家\", true)\n    [\"李小福\", \"是\", \"创新办\", \"任\", \"也\", \"是\", \"云\", \"计算\",\n     \"方面\", \"的\", \"家\"]","ref":"Jieba.html#load_dict!/2-examples"},{"type":"function","title":"Jieba.new/1","doc":"Creates an initializes new Jieba instance.\n\nThis is a convenience wrapper that avoids the need to touch the imperative load_dict/2\nAPI allowing for a more functional calling style.\n\nReturns {:ok, jieba} or {:error, reason}","ref":"Jieba.html#new/1"},{"type":"function","title":"Examples - Jieba.new/1","doc":"iex> {:ok, jieba} = Jieba.new(use_default: false)\n    iex> Jieba.cut(jieba, \"呢個係乜嘢呀\")\n    [\"呢\", \"個\", \"係\", \"乜\", \"嘢\", \"呀\"]\n\n    iex> {:ok, jieba} = Jieba.new()\n    iex> Jieba.cut(jieba, \"呢個係乜嘢呀\")\n    [\"呢\", \"個\", \"係\", \"乜嘢\", \"呀\"]\n    iex> Jieba.cut(jieba, \"李小福是创新办任也是云计算方面的家\")\n    [\"李小福\", \"是\", \"创新\", \"办任\", \"也\", \"是\", \"云\", \"计算\",\n     \"方面\", \"的\", \"家\"]\n\n    iex> {:ok, jieba} = Jieba.new(dict_paths: [\"test/example_userdict.txt\"])\n    iex> Jieba.cut(jieba, \"李小福是创新办任也是云计算方面的家\")\n    [\"李小福\", \"是\", \"创新办\", \"任\", \"也\", \"是\", \"云\", \"计算\",\n     \"方面\", \"的\", \"家\"]\n\n    iex> {:error, :enoent} = Jieba.new(dict_paths: [\"NotAFile.nope.nope\"])","ref":"Jieba.html#new/1-examples"},{"type":"function","title":"Jieba.new!/1","doc":"Creates an initializes new Jieba instance using new/2.\n\nReturns Jieba instance.\n\nRaises Jieba.JiebaError on error.","ref":"Jieba.html#new!/1"},{"type":"function","title":"Examples - Jieba.new!/1","doc":"iex> jieba = Jieba.new!(use_default: false)\n    iex> Jieba.cut(jieba, \"呢個係乜嘢呀\")\n    [\"呢\", \"個\", \"係\", \"乜\", \"嘢\", \"呀\"]","ref":"Jieba.html#new!/1-examples"},{"type":"function","title":"Jieba.suggest_freq/2","doc":"Given a new segment, this attempts to guess the frequency of the segment.\nIt is used by `add_word()` if no `freq` is given.\n\nThis can be used to examine the frequencies of the existing table which\ncan be helpful for tuning or even scaling datasets for dialects of Chinese\nwithout as much corpus data.  For example, if you had a small 粵語 dataset,\nyou could look up common characters like 雨，車，窗 that are not likely to\nhave a huge frequency divergence (as opposed to things like 他 or 地 which\nwhile frequent are far more used in some dialects), find the average delta\nand then scale up the frequencies to match the dictionary you are merging\nin to.\n\nReturns 483 (frequency of the word)","ref":"Jieba.html#suggest_freq/2"},{"type":"function","title":"Examples - Jieba.suggest_freq/2","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.suggest_freq(jieba, \"也\")\n    307852\n    iex> Jieba.suggest_freq(jieba, \"是\")\n    796991\n    iex> Jieba.suggest_freq(jieba, \"也是\")\n    4083\n    iex> Jieba.suggest_freq(jieba, \"佢哋\")\n    1","ref":"Jieba.html#suggest_freq/2-examples"},{"type":"function","title":"Jieba.tag/3","doc":"Takes a sentence, performs `cut()`, and then produces a vector of `Tag` structs that\nlabel each segment with a tag -- usually the part of speech.\n\nReturns `[\n            %Jieba.Tag{word: \"李小福\", tag: \"x\"},\n            %Jieba.Tag{word: \"是\", tag: \"v\"},\n            ...\n         ]`","ref":"Jieba.html#tag/3"},{"type":"function","title":"Examples - Jieba.tag/3","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.tag(jieba, \"李小福是创新办任也是云计算方面的家\", true)\n    [\n            %Jieba.Tag{word: \"李小福\", tag: \"x\"},\n            %Jieba.Tag{word: \"是\", tag: \"v\"},\n            %Jieba.Tag{word: \"创新\", tag: \"v\"},\n            %Jieba.Tag{word: \"办任\", tag: \"x\"},\n            %Jieba.Tag{word: \"也\", tag: \"d\"},\n            %Jieba.Tag{word: \"是\", tag: \"v\"},\n            %Jieba.Tag{word: \"云\", tag: \"ns\"},\n            %Jieba.Tag{word: \"计算\", tag: \"v\"},\n            %Jieba.Tag{word: \"方面\", tag: \"n\"},\n            %Jieba.Tag{word: \"的\", tag: \"uj\"},\n            %Jieba.Tag{word: \"家\", tag: \"q\"}\n          ]","ref":"Jieba.html#tag/3-examples"},{"type":"function","title":"Jieba.textrank_extract_tags/5","doc":"Takes a sentence, and attempts to extract the top_k keywords based on TextRank\nranking.\n\nThis constructs a new TextRank struct each call. If there is no `_stop_words`,\nthis is lightweight. However, if there is, it will reconstruct the internal\ndata structure per call.\n\nWe cannot do better yet because the Jieba-RS interface confusingly requires\nthat the TextRank struct must be bound to a stack-scoped Jieba object. With\nthe Elixir bridge. the Jieba object is actually dynamically allocated and\nshared with a ResourceARC and a Mutex. To do this more properly would\nrequire the Jieba-RS project redesign the TextRank interface so it takes\n`jieba` on the `extract_keyword()` method and not as in the `new()` method.\n\nSee https://github.com/messense/jieba-rs/issues/99 for details.\n\nReturns { :ok,\n          [\n            %Jieba.Keyword{keyword: \"天气\", weight: 19307118367.17687},\n            %Jieba.Keyword{keyword: \"纽约\", weight: 19179632457.07701},\n            %Jieba.Keyword{keyword: \"不好\", weight: 13769629783.10484}\n          ]\n        }","ref":"Jieba.html#textrank_extract_tags/5"},{"type":"function","title":"Examples - Jieba.textrank_extract_tags/5","doc":"iex> jieba = Jieba.new!()\n    iex> {:ok, top_k_tags } = Jieba.textrank_extract_tags(jieba, \"今天纽约的天气真好啊，京华大酒店的张尧经理吃了一只北京烤鸭。后天纽约的天气不好，昨天纽约的天气也不好，北京烤鸭真好吃\", 3)\n    iex> top_k_tags\n    [ %Jieba.Keyword{keyword: \"天气\", weight: 19307118367.17687}, %Jieba.Keyword{keyword: \"纽约\", weight: 19179632457.07701}, %Jieba.Keyword{keyword: \"不好\", weight: 13769629783.10484} ]","ref":"Jieba.html#textrank_extract_tags/5-examples"},{"type":"function","title":"Jieba.textrank_extract_tags!/5","doc":"Uses TextRank algorithm to extract tags.\n\nReturns list of Jieba.Keyword\n\nRaises Jieba.JiebaError on error.","ref":"Jieba.html#textrank_extract_tags!/5"},{"type":"function","title":"Examples - Jieba.textrank_extract_tags!/5","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.textrank_extract_tags!(jieba, \"今天纽约的天气真好啊，京华大酒店的张尧经理吃了一只北京烤鸭。后天纽约的天气不好，昨天纽约的天气也不好，北京烤鸭真好吃\", 3)\n    [ %Jieba.Keyword{keyword: \"天气\", weight: 19307118367.17687}, %Jieba.Keyword{keyword: \"纽约\", weight: 19179632457.07701}, %Jieba.Keyword{keyword: \"不好\", weight: 13769629783.10484} ]","ref":"Jieba.html#textrank_extract_tags!/5-examples"},{"type":"function","title":"Jieba.tfidf_extract_tags/6","doc":"Takes a sentence, and attempts to extract the top_k keywords based on TFIDF\nranking.\n\nThis constructs a new TFIDF struct each call. If there is no `tfidf_dict_path`\nor `_stop_words`, this is lightweight. However, if there is, it will\nreconstruct the internal data structure per call.\n\nWe cannot do better yet because the Jieba-RS interface confusingly requires\nthat the TFIDF struct must be bound to a stack-scoped Jieba object. With\nthe Elixir bridge. the Jieba object is actually dynamically allocated and\nshared with a ResourceARC and a Mutex. To do this more properly would\nrequire the Jieba-RS project redesign the TFIDF interface so it takes\n`jieba` on the `extract_keyword()` method and not as in the `new()` method.\n\nSee https://github.com/messense/jieba-rs/issues/99 for details.\n\nReturns { :ok,\n          [ %Jieba.Keyword{keyword: \"北京烤鸭\", weight: 1.3904870323222223},\n            %Jieba.Keyword{keyword: \"纽约\", weight: 1.121759684755},\n            %Jieba.Keyword{keyword: \"天气\", weight: 1.0766573240983333}\n          ]\n        }","ref":"Jieba.html#tfidf_extract_tags/6"},{"type":"function","title":"Examples - Jieba.tfidf_extract_tags/6","doc":"iex> jieba = Jieba.new!()\n    iex> {:ok, top_k_tags} = Jieba.tfidf_extract_tags(jieba, \"今天纽约的天气真好啊，京华大酒店的张尧经理吃了一只北京烤鸭。后天纽约的天气不好，昨天纽约的天气也不好，北京烤鸭真好吃\", 3)\n    iex> top_k_tags\n    [%Jieba.Keyword{keyword: \"北京烤鸭\", weight: 1.3904870323222223}, %Jieba.Keyword{keyword: \"纽约\", weight: 1.121759684755}, %Jieba.Keyword{keyword: \"天气\", weight: 1.0766573240983333}]\n\n    iex> jieba = Jieba.new!()\n    iex> {:error, :enoent} = Jieba.tfidf_extract_tags(jieba, \"\", 3, [], \"NotAFile.nope.nope\")","ref":"Jieba.html#tfidf_extract_tags/6-examples"},{"type":"function","title":"Jieba.tfidf_extract_tags!/6","doc":"Uses TFIDF algorithm to extract tags.\n\nReturns list of Jieba.Keyword\n\nRaises Jieba.JiebaError on error.","ref":"Jieba.html#tfidf_extract_tags!/6"},{"type":"function","title":"Examples - Jieba.tfidf_extract_tags!/6","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.tfidf_extract_tags!(jieba, \"今天纽约的天气真好啊，京华大酒店的张尧经理吃了一只北京烤鸭。后天纽约的天气不好，昨天纽约的天气也不好，北京烤鸭真好吃\", 3)\n    [%Jieba.Keyword{keyword: \"北京烤鸭\", weight: 1.3904870323222223}, %Jieba.Keyword{keyword: \"纽约\", weight: 1.121759684755}, %Jieba.Keyword{keyword: \"天气\", weight: 1.0766573240983333}]","ref":"Jieba.html#tfidf_extract_tags!/6-examples"},{"type":"function","title":"Jieba.tokenize/4","doc":"Takes a sentence, performs `cut()`, and then produces a vector of `Token` structs that\nindicate where in the sentence the segment comes from.\n\nThe tokenization mode can be one of :default or :search.\n\nReturns `[\n            %{start: 0, __struct__: Jieba.Token, word: \"李小福\"},\n            %{start: 3, __struct__: Jieba.Token, word: \"是\"},[\"是\"]`\n         ]`","ref":"Jieba.html#tokenize/4"},{"type":"function","title":"Examples - Jieba.tokenize/4","doc":"iex> jieba = Jieba.new!()\n    iex> Jieba.tokenize(jieba, \"李小福是创新办任也是云计算方面的家\", :default, true)\n    [\n        %{start: 0, __struct__: Jieba.Token, word: \"李小福\"},\n        %{start: 3, __struct__: Jieba.Token, word: \"是\"},\n        %{start: 4, __struct__: Jieba.Token, word: \"创新\"},\n        %{start: 6, __struct__: Jieba.Token, word: \"办任\"},\n        %{start: 8, __struct__: Jieba.Token, word: \"也\"},\n        %{start: 9, __struct__: Jieba.Token, word: \"是\"},\n        %{start: 10, __struct__: Jieba.Token, word: \"云\"},\n        %{start: 11, __struct__: Jieba.Token, word: \"计算\"},\n        %{start: 13, __struct__: Jieba.Token, word: \"方面\"},\n        %{start: 15, __struct__: Jieba.Token, word: \"的\"},\n        %{start: 16, __struct__: Jieba.Token, word: \"家\"}\n    ]","ref":"Jieba.html#tokenize/4-examples"},{"type":"type","title":"Jieba.t/0","doc":"","ref":"Jieba.html#t:t/0"},{"type":"module","title":"Jieba.Keyword","doc":"Corresponds to a Keyword in the jieba-rs API.\n\n`keyword` is the keyword produced by the jieba-rs TextRank extractor.\n`weight` is the score assigned by the TextRank extractor for the keyword.","ref":"Jieba.Keyword.html"},{"type":"module","title":"Jieba.Tag","doc":"Corresponds to a Tag in the jieba-rs API.\n\n`word` is the string for the token\n`tag` is a string with the tag for the token. These are often parts of speech tags.","ref":"Jieba.Tag.html"},{"type":"module","title":"Jieba.Token","doc":"Corresponds to a Token in the jieba-rs API.\n\n`word` is the string for the token\n`start` and `end` are the locations in the input sentence of `word`.","ref":"Jieba.Token.html"},{"type":"task","title":"mix rust_lint","doc":"The rust_lint mix task: `mix help rust_lint`","ref":"Mix.Tasks.RustLint.html"},{"type":"function","title":"Mix.Tasks.RustLint.run/1","doc":"","ref":"Mix.Tasks.RustLint.html#run/1"},{"type":"exception","title":"Jieba.JiebaError","doc":"","ref":"Jieba.JiebaError.html"},{"type":"extras","title":"Jieba","doc":"# Jieba\n\n![Build](https://github.com/awong-dev/jieba/actions/workflows/ci.yml/badge.svg)\n![semver](https://img.shields.io/badge/semver-0.3.0-blue)\n![Hex.pm](https://img.shields.io/hexpm/v/jieba)\n\n([Note for versions 0.2.0 and earlier](#0.2.0-and-earlier))\n\nA Rustler bridge to [jieba-rs](https://github.com/messense/jieba-rs), the Rust\nJieba implementation.\n\nThis provides the ability to use the Jieba-rs segmenter in Elixir for segmenting\nChinese text.\n\nThe API is mostly a direct mapping of the Rust API. The constructors have all\nbeen combined under one `new/2` API that allows the code to feel less imperative.\n\nThe KeywordExtract functionality for both `TFIDF` and `TextRank` are also provided\nbut due to the design of `jieba-rs` that restricts to project those two Rust\nstructs into the Beam while respecting the Rust lifetime rules and ensuring mutual\nexclusion across threads, they are exported as single use functions that\nconstruct/tear-down the `TFIDF` and `TextRank` instances per call.  This is\npossibly slow but fixing it to be fast would require modifying the `jieba-rs`\nAPI so that neither `TFIDF` or `TextRank` held a reference to the underlying\n`jieba` instance on construction and instead took the wanted instance on the\n`extract_tags()` call.","ref":"readme.html"},{"type":"extras","title":"Installation - Jieba","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `jieba` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:jieba, \"~> 0.3.1\"}\n  ]\nend\n```\n\n##  Versions prior to 0.2.0 \nVersions prior to 0.2.0 were written by [mjason](https://github.com/mjason)\n([lmj](https://hex.pm/users/lmj) on hex and released from the\n[mjason/jieba_ex](https://github.com/mjason/jieba_ex) source tree. It exposed\na single `Jieba.cut(sentence)` method will used a single, unsyncrhonized, static\ninstance of Jieba on the Rust side loaded with the default dictionary.\nThe `cut(sentence)` was hardcoded to have `hmm=false`.\n\nIn March 2024, this codebase was written to help with the\n[Visual Fonts](https://visual-fonts.com/) project, not realizing an existing\ncodebase was available. This codebase had a more complete exposure of the Rust\nAPI. After talking with `mjason`, it was decided to switch to this codebase and\nto increment the version number to signify the API break.\n\nThe 0.3.z versions still include `Jieba.cut/1` interface, but have it marked\ndeprecated. In 1.0.0, this API will be removed in favor of non-global-object\nbased API.","ref":"readme.html#installation"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.1.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n#","ref":"changelog.html"},{"type":"extras","title":"Unreleased - Changelog","doc":"Nothing.\n\n## [0.3.1] 2024-03-31\nClean-up CI, Readme, and Docs. Precompile binaries for common platforms.\n\n#","ref":"changelog.html#unreleased"},{"type":"extras","title":"Added - Changelog","doc":"1. RustlerPrecompile\n\n## [0.3.0] 2024-03-30\n\n  1. This release comes from an entirely new codebase: [awong-dev/jieba](https://github.com/awong-dev/jieba).\n  2. Ownership of `hex.pm` package changed from [lmi](https://hex.pm/users/lmj) to [awong.dev](https://hex.pm/users/awong.dev)\n\nImplementation of `awong-dev/jieba` was spurred by the\n[Visual Fonts](https://visual-fonts.com/) project and was code-complete with\n`jieba_rs` API exposed in a thread-safe manner (complete with documentation\nand tests) before noticing that there was an exisitng `hex.pm` jieba pakcage.\n\nAfter the name collision was discovered, `ljm` and `awong-dev` decided to\ntransfer package ownership and release a new version of `jieba` using the\nnew codebase.\n\nThe previous 0.2.0 API was added into the `awong-dev/jieba` implementation\nas a deprecated API for the 0.3.0 release and will be removed later.\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"1. Ability to create multiple `Jieba` instances instead of depending on one global one.\n  2. APIs exposing all functionality in [messense/jieba_rs](https://github.com/messense/jieba-rs) including\n      1. Ability to load custom dictionaries to extend the segmentation\n      2. Simple exposure of the [TFIDF](https://docs.rs/jieba-rs/0.6.8/jieba_rs/struct.TFIDF.html) and [TextRank](https://docs.rs/jieba-rs/0.6.8/jieba_rs/struct.TextRank.html) APIs\n  3. Doctests for all exposed APIs\n\n#","ref":"changelog.html#added"},{"type":"extras","title":"Deprecated - Changelog","doc":"1. `Jieba.cut/1` is being removed because other APIs are more flexible and provide full thread-safety guarantees.\n\n#","ref":"changelog.html#deprecated"},{"type":"extras","title":"Changed - Changelog","doc":"1. hex.pm jieba packaged ownership transfered from `ljm` to `awong-dev`\n  2. Source tree is now at [awong-dev/jieba](https://github.com/awong-dev/jieba)\n  3. Documentation written primarily in English\n\n\n## [0.2.0] and prior - 2021-07-13\nVersions 0.2.0 and prior are released from the\n[mjason/jieba_ex](https://github.com/mjason/jieba_ex) project and feature a\nsingle, lazily initialized, Rust Jieba instance that can be accessed in\nelixir via the `Jieba.cut/1` function. This would return the result of cut in\n`Jieba_rs` with the default dictionary and `hmm` turned off.\n\n\nAll concurrent calls from Elixir would have unsynchronized access to the\nunderlying Rust Jieba instance.\n\nVersions before 0.2.0 contain various build tweaks.","ref":"changelog.html#changed"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2024 Albert J. Wong\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}